<?php
/*
Plugin Name: Ticket 24712 Test
Description: https://core.trac.wordpress.org/ticket/24712
Author: Pete Nelson
Version: 1.0
*/

if (!defined( 'ABSPATH' )) exit('restricted access');

add_shortcode( 'ticket-24712-test', 'ticket_24712_shortcode' );

function ticket_24712_shortcode( $args ) {

	$args = wp_parse_args( $args, array( 'url' => '' ) );

	$results = wp_oembed_get( $args['url'] );
	$oembed = _wp_oembed_get_object();

	if ( empty ( $oembed->errors ) ) {
		echo $results;
	}
	else {
		?>
			<p>
				<?php
					if ( in_array('parse-json-failed', $oembed->errors ) ) echo 'Unable to parse JSON response';
					if ( in_array('parse-xml-failed', $oembed->errors ) ) echo 'Unable to parse XML response';
				?>
				<br/>
				Response Body: <?php echo esc_attr( $oembed->response_body ); ?>
			</p>
		<?php
	}

}
